<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Asinhrono programiranje - asinhrone funkcije</title>
  </head>
  <body>
    <h3>async/await</h3>

    <script>
      // Asinhron kod koji koristi obecanja mozemo uciniti "sinhronim" u 2 koraka:
      // 1) Potrebna nam je funkcija koja je oznacena kljucnom recju async.
      // Ovo je neophodno zato sto kljucna rec await (koja se koristi ispod)
      // ne moze se koristiti u globalnom opsegu u veb pregledacu (osim ako nije u modulu).
      async function doStuff() {
        const promise = new Promise(function (resolve, reject) {
          resolve("Obećanje je ispunjeno!");
        });

        // 2) Ispred obecanja dodajemo kljucnu rec await koja ce "sacekati" da se obecanje ispuni.
        // Vrednost promenljive value ispod ce biti vrednost kojom je obecanje ispunjeno.
        const value = await promise;
        // Kod "ispod" await kljucne reci ce se izvrsiti asinhrono.
        document.body.appendChild(document.createTextNode(value));
      }

      doStuff();
    </script>
  </body>
</html>
